This patch is against ISODE 8.0.1. If you don't have ISODE 8.0 or the
patch 1 for it they can be found on src.doc.ic.ac.uk:packages/isode
among other archives.

  The major part of this adds support for building a Linux DLL library
to the makefiles. Do ./make first. This will build libraries, pepsy,
pepy etc. as normal. Then do ./make linux-libs to build the shared
library. It isn't clean, it isn't neat. You will probably have to do some
fudging by hand. A shared library is worth it though unless you have
gigabytes of free disk space to waste :-).

  There are also changes to add termios support to various places, POSIX
changes etc. However it is mostly a case of making some good choices in
the config.h and config.make files, see config/linux.*. Async mode is
done with the isore kludge. I looked at putting SIGIO in the Linux kernel
and decided this was not a trivial job. PP requires async mode so isore
is the only choice.

  These patches get most things working to a reasonable-ish degree I think.
Certainly quipu, dish, pod seem happy, the problem is in figuring out how
to set them up if you don't have much experience. The ISODE documentation
is not supplied with ISODE 8.0 - you need the documentation from one of
the earlier distributions. The documentation comes in the form of several
big, thick manuals in TeX format. These are development oriented rather
than end-user oriented though :-).

  PP still has problems. In particular qmgr bombs with a sig 11 apparently
due to heap corruption. Unfortunately this *only* happens with the libc
malloc and not my debugging malloc which detects no invalid pointers,
over/underruns, chain corruption etc. Given the rate libc malloc keeps
moving at the moment this problem isn't exactly amenable to solution
right now...

  You want a fair amount of memory to run ISODE. I have 16MB. 8MB is
swapsville. For ISODE development I wouldn't recommend less than 16MB.
I wish I had more :-(.

  This is *ALPHA*. It might change drastically for no apparent reason.
It hasn't for quite a while but then I haven't been working on it for
quite a while :-).

  I'll try and put some packages of binaries together at some stage too
perhaps...


  Mike Jagdis <jaggy@purplet.demon.co.uk>



diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/Makefile isode-8.0/Makefile
--- old/isode-8.0/Makefile	Tue Jun 16 13:05:02 1992
+++ isode-8.0/Makefile	Fri Aug 27 14:52:35 1993
@@ -31,7 +31,12 @@
 ##################################################################
 
 LIBDIRS	=	h compat dirent tsap ssap psap pepsy pepy psap2 \
-		acsap rosap rtsap ronot rosy 
+		acsap rosap rtsap ronot rosy
+# If you don't want lpp use psap2 instead of psap2-lpp
+LINUXISODE=	rosy ronot rosap rtsap acsap psap2 pepy pepsy psap \
+		ssap tsap dirent compat support
+LINUXDSAP=	dsap
+LINUXFTAM=	ftam
 DIRS	=	$(LIBDIRS) support imisc
 OTHERS	=	dsap ftam ftam2 ftam-ftp ftp-ftam others psap2-lpp quipu \
 		snmp vt
@@ -41,6 +46,26 @@
 		    do (echo "cd $$i; $(MAKE) all"; \
 			      cd $$i; $(MAKE) all); \
 		    done
+
+linux-libs:
+		@for i in $(LINUXISODE); \
+			do (echo "cd $$i; $(MAKE) linux-lib"; \
+				cd $$i; \
+				JUMP_DIR=../jump/ JUMP_LIB=libisode \
+				JUMP_OPT=-B/usr/dll/jump/ $(MAKE) linux-lib); \
+			done
+		@for i in $(LINUXDSAP); \
+			do (echo "cd $$i; $(MAKE) linux-lib"; \
+				cd $$i; \
+				JUMP_DIR=../jump/ JUMP_LIB=libdsap \
+				JUMP_OPT=-B/usr/dll/jump/ $(MAKE) linux-lib); \
+			done
+		@for i in $(LINUXFTAM); \
+			do (echo "cd $$i; $(MAKE) linux-lib"; \
+				cd $$i; \
+				JUMP_DIR=../jump/ JUMP_LIB=libftam \
+				JUMP_OPT=-B/usr/dll/jump/ $(MAKE) linux-lib); \
+			done
 
 inst-all:	make-dirs
 		@for i in $(DIRS); \
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/acsap/Makefile isode-8.0/acsap/Makefile
--- old/isode-8.0/acsap/Makefile	Tue Jun 16 13:05:59 1992
+++ isode-8.0/acsap/Makefile	Wed Aug 25 14:27:10 1993
@@ -84,6 +84,20 @@
 
 inst-libacsap:	$(LIBDIR)libacsap.a $(LINTDIR)llib-lacsap
 
+zap-acsap:
+		-rm -f $(OFILES) libacsap.a \
+			ACS_tables.o OACS_tables.o DSE_tables.o DASE_tables.o \
+			acsapvrsn.o
+
+linux-lib:	zap-acsap ../jump/libacsap.a
+
+../jump/libacsap.a:	libacsap
+		-rm -f $@
+		cp libacsap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libacsap.a:	libacsap.a
 		-rm -f $@
 		cp libacsap.a $@
@@ -234,6 +248,7 @@
 		-@echo ""
 
 dased:		xdased
+		:
 
 xdased:		dased.o DASE_tables.o $(TOPDIR)libdsap.a $(TOPDIR)libisode.a
 		$(LDCC) $(LDFLAGS) -o $@ dased.o DASE_tables.o \
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/Makefile isode-8.0/compat/Makefile
--- old/isode-8.0/compat/Makefile	Tue Jun 16 13:07:00 1992
+++ isode-8.0/compat/Makefile	Tue Aug 24 11:53:55 1993
@@ -79,6 +79,18 @@
 
 inst-libcompat:	$(LIBDIR)libicompat.a $(LINTDIR)llib-licompat
 
+zap-compat:
+		-rm -f $(OFILES) libcompat.a compatvrsn.o
+
+linux-lib:	zap-compat ../jump/libcompat.a
+
+../jump/libcompat.a:	libcompat.a
+		-rm -f $@
+		cp libcompat.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libicompat.a:	libcompat.a
 		-rm -f $@
 		cp libcompat.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/asprintf.c isode-8.0/compat/asprintf.c
--- old/isode-8.0/compat/asprintf.c	Tue Jun 16 13:07:00 1992
+++ isode-8.0/compat/asprintf.c	Wed May 26 17:10:05 1993
@@ -27,8 +27,9 @@
 
 /* LINTLIBRARY */
 
-#include <stdio.h>
 #include <varargs.h>
+#define _STDARG_H
+#include <stdio.h>
 #include "general.h"
 #include "manifest.h"
 
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/general.c isode-8.0/compat/general.c
--- old/isode-8.0/compat/general.c	Tue Jun 16 13:07:06 1992
+++ isode-8.0/compat/general.c	Mon Aug 23 10:05:08 1993
@@ -79,7 +79,7 @@
 
 /*    DUP2 */
 
-#ifndef	BSD42
+#if !defined(BSD42) && !defined(__linux__)
 #ifdef	SYS5
 #include <fcntl.h>
 #endif
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/getpassword.c isode-8.0/compat/getpassword.c
--- old/isode-8.0/compat/getpassword.c	Tue Jun 16 13:07:06 1992
+++ isode-8.0/compat/getpassword.c	Thu Aug 19 12:45:14 1993
@@ -32,6 +32,9 @@
 #include "general.h"
 #include "manifest.h"
 #include "sys.file.h"
+#ifdef _POSIX_SOURCE
+#include <termios.h>
+#endif
 
 #ifdef	BSD44
 char   *getpass ();
@@ -51,7 +54,11 @@
     register char  *bp,
 		   *ep;
 #if	!defined(SYS5) && !defined(XOS_2)
+#if defined(_POSIX_SOURCE)
+    struct termios  sg;
+#else
     struct sgttyb   sg;
+#endif
 #else
     struct termio   sg;
 #endif
@@ -75,10 +82,17 @@
     istat = signal (SIGINT, SIG_IGN);
 
 #if	!defined(SYS5) && !defined(XOS_2)
+#if defined(_POSIX_SOURCE)
+    tcgetattr (fileno (fp), &sg);
+    flags = sg.c_lflag;
+    sg.c_lflag &= ~ECHO;
+    tcsetattr (fileno (fp), TCSADRAIN, &sg);
+#else
     (void) gtty (fileno (fp), &sg);
     flags = sg.sg_flags;
     sg.sg_flags &= ~ECHO;
     (void) stty (fileno (fp), &sg);
+#endif
 #else
     (void) ioctl (fileno (fp), TCGETA, (char *) &sg);
     flags = sg.c_lflag;
@@ -115,8 +129,13 @@
 #endif
 
 #if	!defined(SYS5) && !defined(XOS_2)
+#if defined(_POSIX_SOURCE)
+    sg.c_lflag = flags;	
+    tcsetattr (fileno (fp), TCSADRAIN, &sg);
+#else
     sg.sg_flags = flags;
     (void) stty (fileno (fp), &sg);
+#endif
 #else
     sg.c_lflag = flags;
     (void) ioctl (fileno (fp), TCSETAW, (char *) &sg);
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/internet.c isode-8.0/compat/internet.c
--- old/isode-8.0/compat/internet.c	Tue Jun 16 13:07:09 1992
+++ isode-8.0/compat/internet.c	Tue Sep  7 11:49:18 1993
@@ -178,7 +178,7 @@
     }
 
 got_socket: ;
-#if	!defined(BSD43) && !defined(SVR4)
+#if	!defined(BSD43) && !defined(SVR4) && !defined(__linux__)
     if (setsockopt (sd, SOL_SOCKET, SO_KEEPALIVE, NULLCP, 0) == NOTOK)
 	SLOG (compat_log, LLOG_EXCEPTIONS, "failed", ("set SO_KEEPALIVE"));
     if (opt1 && setsockopt (sd, SOL_SOCKET, opt1, NULLCP, 0) == NOTOK)
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/logger.c isode-8.0/compat/logger.c
--- old/isode-8.0/compat/logger.c	Tue Jun 16 13:07:16 1992
+++ isode-8.0/compat/logger.c	Wed May 26 17:08:46 1993
@@ -27,8 +27,9 @@
 
 /* LINTLIBRARY */
 
-#include <stdio.h>
 #include <varargs.h>
+#define _STDARG_H
+#include <stdio.h>
 #include "general.h"
 #include "manifest.h"
 #include "logger.h"
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/putenv.c isode-8.0/compat/putenv.c
--- old/isode-8.0/compat/putenv.c	Tue Jun 16 13:07:19 1992
+++ isode-8.0/compat/putenv.c	Thu Aug 19 12:58:10 1993
@@ -31,6 +31,8 @@
 #include "general.h"
 #include "manifest.h"
 
+#ifndef _POSIX_SOURCE
+
 /*  */
 
 extern  char **environ;
@@ -104,3 +106,5 @@
 
     return (*s1 == '\0' && *--s2 == '=');
 }
+
+#endif /* _POSIX_SOURCE */
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/compat/strdup.c isode-8.0/compat/strdup.c
--- old/isode-8.0/compat/strdup.c	Tue Jun 16 13:07:33 1992
+++ isode-8.0/compat/strdup.c	Mon Aug 23 10:14:50 1993
@@ -33,7 +33,7 @@
 #include "tailor.h"
 
 /*  */
-#if !defined(SVR4) || defined(_AIX)
+#if (!defined(SVR4) && !defined(__linux__)) || defined(_AIX)
                       /* strdup in AIX does not seem to use QUIPUs malloc! */
 
 char   *strdup (str)
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/config/linux.h isode-8.0/config/linux.h
--- old/isode-8.0/config/linux.h	Thu Jan  1 01:00:00 1970
+++ isode-8.0/config/linux.h	Fri Sep 10 16:00:21 1993
@@ -0,0 +1,30 @@
+#ifndef	_CONFIG_
+#define	_CONFIG_
+
+#define WRITEV
+#define SVR4_UCB		/* we have some of these bits too */
+#define LINUX			/* more strictly Linux */
+
+#define BSDSIGS			/* BSD style signals work. */
+
+#undef	SIGPOLL			/* None of these actual work... */
+#undef	SIGIO
+#undef	SIGURG
+#undef	SIGEMT
+
+#define BSDLIBC			/* We have the BSD insque/remque. */
+#define SWAPLIB			/* Can swap between local and net byte order */
+#define SHADOW_PW		/* use shadow password file */
+#define VSPRINTF
+#define TEMPNAM
+
+#define GETDENTS
+#define NFS			/* NFS implies GETDENTS too I think. */
+
+#define	TCP			/* has TCP/IP (of course) */
+#define	SOCKETS			/*   provided by sockets */
+#define BIND
+
+#define RFINGER "/usr/bin/finger"
+
+#endif
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/config/linux.make isode-8.0/config/linux.make
--- old/isode-8.0/config/linux.make	Thu Jan  1 01:00:00 1970
+++ isode-8.0/config/linux.make	Thu Aug 26 16:25:07 1993
@@ -0,0 +1,86 @@
+###############################################################################
+#   Instructions to Make, for compilation of ISODE processes for 4.3BSD UNIX
+###############################################################################
+
+###############################################################################
+#
+# $Header: /xtel/isode/isode/config/RCS/bsd43.make,v 9.0 1992/06/16 12:08:13 isode Rel $
+#
+#
+# $Log: bsd43.make,v $
+# Revision 9.0  1992/06/16  12:08:13  isode
+# Release 8.0
+#
+#
+###############################################################################
+
+###############################################################################
+#
+#				 NOTICE
+#
+#    Acquisition, use, and distribution of this module and related
+#    materials are subject to the restrictions of a license agreement.
+#    Consult the Preface in the User's Manual for the full terms of
+#    this agreement.
+#
+###############################################################################
+
+
+###############################################################################
+# Options
+###############################################################################
+
+OPTIONS	=	-I. -I$(TOPDIR)h $(PEPYPATH) $(KRBOPT)
+
+HDIR	=	$(TOPDIR)h/
+UTILDIR	=	$(TOPDIR)util/
+BINDIR	=	/usr/local/bin/
+SBINDIR	=	/usr/etc/
+ETCDIR	=	/usr/etc/
+LOGDIR	=	/usr/tmp/
+INCDIRM	=	/usr/include/isode
+INCDIR	=	$(INCDIRM)/
+PEPYDIRM=	$(INCDIR)pepy
+PEPYDIR	=	$(PEPYDIRM)/
+PEPSYDIRM=	$(INCDIR)pepsy
+PEPSYDIR=	$(PEPSYDIRM)/
+LIBDIR	=	/usr/lib/
+LINTDIR	=	/usr/lib/lint/
+
+LIBISODE=	$(TOPDIR)libisode.a
+LIBDSAP	=	$(TOPDIR)libdsap.a
+
+SYSTEM	=	-bsd42
+MANDIR	=	/usr/man/
+MANOPTS	=	-bsd42
+
+
+###############################################################################
+# Programs and Libraries
+###############################################################################
+
+MAKE	=	./make DESTDIR=$(DESTDIR) $(MFLAGS) -k
+SHELL	=	/bin/sh
+
+CC      =	cc $(JUMP_OPT)
+CFLAGS  =	-O6 -fomit-frame-pointer -m486 -D__STDC__=1 -D__USE_BSD_SIGNALS $(OPTIONS)
+LIBCFLAGS=	      $(CFLAGS)
+LINT    =	lint
+LFLAGS  =	-bhuz $(OPTIONS)
+LD	=	ld
+LDCC	=	$(CC)
+LDFLAGS =	-s
+ARFLAGS	=
+
+LN	=	ln
+
+LSOCKET	=	$(KRBLIB) -lshadow -ldbm -lm
+
+
+###############################################################################
+# Generation Rules for library modules
+###############################################################################
+
+.c.o:;		$(CC) $(LIBCFLAGS) -c $*.c
+		-ld -x -r $@
+		mv a.out $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/dirent/Makefile isode-8.0/dirent/Makefile
--- old/isode-8.0/dirent/Makefile	Tue Jun 16 11:17:26 1992
+++ isode-8.0/dirent/Makefile	Tue Aug 24 11:53:42 1993
@@ -45,6 +45,18 @@
 
 inst-libdirent:	$(LIBDIR)libdirent.a $(LINTDIR)llib-ldirent
 
+zap-dirent:
+		-rm -f $(OFILES) libdirent.a direntvrsn.o
+
+linux-lib:	zap-dirent ../jump/libdirent.a
+
+../jump/libdirent.a:	libdirent.a
+		-rm -f $@
+		cp libdirent.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libdirent.a:	libdirent.a
 		-rm -f $@
 		cp libdirent.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/dirent/scandir.c isode-8.0/dirent/scandir.c
--- old/isode-8.0/dirent/scandir.c	Tue Jun 16 11:17:27 1992
+++ isode-8.0/dirent/scandir.c	Fri Dec  3 13:27:01 1993
@@ -19,6 +19,8 @@
  * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
  */
 
+#ifndef __linux__
+
 #if defined(LIBC_SCCS) && !defined(lint)
 static char sccsid[] = "@(#)scandir.c	5.9 (Berkeley) 6/24/90";
 #endif /* LIBC_SCCS and not lint */
@@ -121,3 +123,8 @@
 	return(strcmp((*(struct dirent **)d1)->d_name,
 	    (*(struct dirent **)d2)->d_name));
 }
+
+#else
+int	_scandir_stub () {;}
+int	_alphasort_stub () {;}
+#endif
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/dsap/Makefile isode-8.0/dsap/Makefile
--- old/isode-8.0/dsap/Makefile	Tue Jun 16 13:12:27 1992
+++ isode-8.0/dsap/Makefile	Wed Aug 25 08:35:46 1993
@@ -48,6 +48,16 @@
 clean:		sub-clean
 	        rm -f lib*.a lib*.so* llib-l* _* *.tmp *.orig *.o z* dsapvrsn.c
 		rm -f libdsap-shared
+
+linux-lib:	dsap-linux linux-subs
+
+linux-subs:
+		@for i in $(DIRS); \
+			do (echo "cd $$i; $(MAKE) linux-lib"; \
+				cd $$i; \
+				JUMP_DIR=../../jump/ JUMP_LIB=libdsap \
+				JUMP_OPT=-B/usr/dll/jump/ $(MAKE) linux-lib); \
+			done
 sub-all:
 		@for i in $(DIRS); \
 		    do (echo "cd $$i; $(MAKE) all"; \
@@ -79,6 +89,18 @@
 inst-libdsap:   inst-headers $(LIBDIR)libdsap.a $(LINTDIR)llib-ldsap
 
 inst-headers:;	cd x500as; $(MAKE) inst-headers
+
+inst-libcompat:	$(LIBDIR)libicompat.a $(LINTDIR)llib-licompat
+
+zap-dsap:
+		-rm -f dsapvrsn.o
+
+dsap-linux:	zap-dsap ../jump/libdsap.a
+
+../jump/libdsap.a:	dsapvrsn.o
+		-rm -f $@
+		ar q $@ dsapvrsn.o
+		-@echo ""
 
 $(LIBDIR)libdsap.a:     libdsap.a
 		@for i in libdsap.* ;\
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/dsap/common/Makefile isode-8.0/dsap/common/Makefile
--- old/isode-8.0/dsap/common/Makefile	Tue Jun 16 13:12:40 1992
+++ isode-8.0/dsap/common/Makefile	Tue Aug 24 12:10:09 1993
@@ -128,6 +128,18 @@
 		$(LINT) $(LFLAGS) $(CFILES) $(LLIBS) \
 			| grep -v "warning: possible pointer alignment problem"
 
+zap-common:
+		-rm -f $(OFILES) libcommon.a commonvrsn.o
+
+linux-lib:	zap-common ../../jump/libcommon.a
+
+../../jump/libcommon.a:	libcommon.a
+		-rm -f $@
+		cp libcommon.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 test:		test.o libcommon.a ../libx500as.a
 		$(LDCC) $(LDFLAGS) test.o libcommon.a ../libx500as.a \
 			libcommon.a $(LIBISODE) -o test
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/dsap/common/integer.c isode-8.0/dsap/common/integer.c
--- old/isode-8.0/dsap/common/integer.c	Tue Jun 16 13:13:16 1992
+++ isode-8.0/dsap/common/integer.c	Fri Aug 20 10:52:48 1993
@@ -108,7 +108,9 @@
 static int * intparse (str)
 char * str;
 {
+#ifndef atoi
 int atoi();
+#endif
 int * x;
 
 	x = (int *) smalloc (sizeof (int));
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/dsap/net/Makefile isode-8.0/dsap/net/Makefile
--- old/isode-8.0/dsap/net/Makefile	Tue Jun 16 13:14:06 1992
+++ isode-8.0/dsap/net/Makefile	Tue Aug 24 12:11:13 1993
@@ -88,6 +88,18 @@
 netvrsn.c:      $(OFILES)
 		@$(UTILDIR)version.sh net > $@
 
+zap-net:
+		-rm -f $(OFILES) libnet.a netvrsn.o
+
+linux-lib:	zap-net ../../jump/libnet.a
+
+../../jump/libnet.a:	libnet.a
+		-rm -f $@
+		cp libnet.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 l-libnet:       $(CFILES) true
 		$(LINT) $(LFLAGS) $(CFILES) $(LLIBS) \
 			| grep -v "warning: possible pointer alignment problem"
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/dsap/x500as/Makefile isode-8.0/dsap/x500as/Makefile
--- old/isode-8.0/dsap/x500as/Makefile	Tue Jun 16 13:14:33 1992
+++ isode-8.0/dsap/x500as/Makefile	Tue Aug 24 12:08:21 1993
@@ -81,6 +81,18 @@
 l-libx500as:;	$(LINT) $(LFLAGS) $(CFILES) $(PEPY-C) $(LLIBS) \
 			| grep -v "warning: possible pointer alignment problem"
 
+zap-x500as:
+		-rm -f $(OFILES) libx500as.a x500asvrsn.o
+
+linux-lib:	zap-x500as ../../jump/libx500as.a
+
+../../jump/libx500as.a:	libx500as.a
+		-rm -f $@
+		cp libx500as.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 
 #######################################################
 # saber
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftam/Makefile isode-8.0/ftam/Makefile
--- old/isode-8.0/ftam/Makefile	Tue Jun 16 13:14:56 1992
+++ isode-8.0/ftam/Makefile	Wed Aug 25 14:33:01 1993
@@ -78,6 +78,19 @@
 
 inst-libftam:	$(LIBDIR)libftam.a inst-headers $(LINTDIR)llib-lftam
 
+zap-ftam:
+		-rm -f $(OFILES) libftam.a \
+			CONT_tables.o FADU_tables.o FTAM_tables.o ftamvrsn.o
+
+linux-lib:	zap-ftam ../jump/libftam.a
+
+../jump/libftam.a:	libftam
+		-rm -f $@
+		cp libftam.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libftam.a:	libftam.a
 		-rm -f $@
 		cp libftam.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftam2/Makefile isode-8.0/ftam2/Makefile
--- old/isode-8.0/ftam2/Makefile	Tue Jun 16 13:15:44 1992
+++ isode-8.0/ftam2/Makefile	Mon Aug 23 14:19:27 1993
@@ -72,6 +72,7 @@
 		-@echo ""
 
 ftamd:		xftamd
+		:
 
 xftamd:		ftamd.o ftamsystem.o ftamd-manage.o ftamd-select.o \
 			ftamd-trans.o ftamsbr.o DOCS_tables.o $(LIBD)
@@ -107,6 +108,7 @@
 		-@echo ""
 
 ftam:		xftam
+		:
 
 xftam:		ftam.o ftamuser.o ftam-assoc.o ftam-dir.o ftam-get.o \
 			ftam-glob.o ftam-ls.o ftam-mgmt.o ftam-put.o \
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftam2/ftam-get.c isode-8.0/ftam2/ftam-get.c
--- old/isode-8.0/ftam2/ftam-get.c	Tue Jun 16 13:15:45 1992
+++ isode-8.0/ftam2/ftam-get.c	Fri Aug 20 12:56:07 1993
@@ -27,6 +27,9 @@
 
 #include <errno.h>
 #include <stdio.h>
+#ifdef _POSIX_SOURCE
+#include <unistd.h>
+#endif
 #include "ftamuser.h"
 
 /*  */
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftam2/ftamd-select.c isode-8.0/ftam2/ftamd-select.c
--- old/isode-8.0/ftam2/ftamd-select.c	Tue Jun 16 13:15:49 1992
+++ isode-8.0/ftam2/ftamd-select.c	Fri Aug 20 12:42:19 1993
@@ -28,6 +28,9 @@
 #include <grp.h>
 #include <stdio.h>
 #include <pwd.h>
+#ifdef _POSIX_SOURCE
+#include <unistd.h>
+#endif
 #include "ftamsystem.h"
 
 
@@ -63,6 +66,10 @@
 #endif
 
 
+#if !defined(SYS5) && !defined(BRIDGE)
+static int  EACCESS ();
+#endif
+
 #ifdef	SYS5
 #define	EACCESS	access
 
@@ -1528,13 +1535,21 @@
 {
     int	    result;
 
+#ifdef _POSIX_SOURCE
+    (void) setreuid (myuid, 0);
+#else
     (void) seteuid (0);
     (void) setruid (myuid);
+#endif
 
     result = access (file, mode);
 
+#ifdef _POSIX_SOURCE
+    (void) setreuid (0, myuid);
+#else
     (void) setruid (0);
     (void) seteuid (myuid);
+#endif
 
     return result;
 }
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftam2/ftamd-trans.c isode-8.0/ftam2/ftamd-trans.c
--- old/isode-8.0/ftam2/ftamd-trans.c	Tue Jun 16 13:15:50 1992
+++ isode-8.0/ftam2/ftamd-trans.c	Fri Aug 20 12:20:19 1993
@@ -31,6 +31,10 @@
 #include <sys/times.h>
 #define	TMS
 #endif
+#ifdef _POSIX_SOURCE
+#include <sys/times.h>
+#define TMS
+#endif
 
 /*    DATA */
 
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftam2/ftamsystem.c isode-8.0/ftam2/ftamsystem.c
--- old/isode-8.0/ftam2/ftamsystem.c	Tue Jun 16 13:15:52 1992
+++ isode-8.0/ftam2/ftamsystem.c	Tue Aug 31 14:33:30 1993
@@ -44,6 +44,7 @@
 
 #ifdef SHADOW_PW
 #include <shadow.h>
+#include <shadow/pwauth.h>
 #endif
 
 #ifdef	SYS5
@@ -345,14 +346,23 @@
       else
           pw->pw_passwd = shad_res->sp_pwdp;
     }
-#endif /* SHADOW_PW */
-
 
+    if (!guest) {
+          if (pw->pw_passwd && pw->pw_passwd[0] == '@'
+          && pw_auth(pw->pw_passwd, pw->pw_name, PW_FTP, fts->fts_password)) {
+               seterr (FS_ACS_PASSWORD, EREF_RFSU, EREF_IFSU, "");
+          } else if (!valid(fts->fts_password, pw)) {
+               seterr (FS_ACS_PASSWORD, EREF_RFSU, EREF_IFSU, "");
+          }
+    }
+#else /* SHADOW_PW */
     if ((!guest && fts -> fts_password == NULL)
 	    || *pw -> pw_passwd == NULL
 	    || (!guest && !chkpassword (initiator, pw -> pw_passwd,
 					fts -> fts_password)))
 	seterr (FS_ACS_PASSWORD, EREF_RFSU, EREF_IFSU, "");
+#endif /* SHADOW_PW */
+
 
 #ifdef DEBUG
     advise (LLOG_DEBUG, NULLCP,
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftam2/ftamuser.c isode-8.0/ftam2/ftamuser.c
--- old/isode-8.0/ftam2/ftamuser.c	Tue Jun 16 13:15:53 1992
+++ isode-8.0/ftam2/ftamuser.c	Fri Aug 20 12:54:35 1993
@@ -34,6 +34,10 @@
 #include <sys/times.h>
 #define	TMS
 #endif
+#ifdef _POSIX_SOURCE
+#include <sys/times.h>
+#define TMS
+#endif
 #ifdef	BSD42
 #include <sys/ioctl.h>
 #endif
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ftp-ftam/version isode-8.0/ftp-ftam/version
--- old/isode-8.0/ftp-ftam/version	Tue Jun 16 11:53:35 1992
+++ isode-8.0/ftp-ftam/version	Mon Aug 23 14:21:59 1993
@@ -1 +1 @@
-115
+117
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/h/general.h isode-8.0/h/general.h
--- old/isode-8.0/h/general.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0/h/general.h	Thu Aug 19 10:08:42 1993
@@ -270,6 +270,7 @@
 
 /*  ntohs etc */
 
+#ifndef __linux__
 #ifndef	ntohs
 unsigned short	ntohs ();
 #endif
@@ -282,6 +283,7 @@
 #ifndef	htonl
 unsigned long	htonl ();
 #endif
+#endif /* __linux__ */
 
 int	char2bcd ();
 int	bcd2char ();
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/h/manifest.h isode-8.0/h/manifest.h
--- old/isode-8.0/h/manifest.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0/h/manifest.h	Fri Sep 10 15:57:52 1993
@@ -200,7 +200,7 @@
 #include <sys/select.h>
 #endif
 
-#ifdef	SYS5NLY
+#ifdef SYS5NLY
 typedef unsigned char	u_char;
 typedef unsigned short	u_short;
 typedef unsigned int	u_int;
@@ -303,7 +303,7 @@
 /*    POSIX */
 
 #ifndef	SETSID
-#if	defined(SUNOS41) || defined(BSD44) || defined (SVR4) || defined(_AIX)
+#if	defined(SUNOS41) || defined(BSD44) || defined (SVR4) || defined(_AIX) | defined(__linux__)
 #define	SETSID
 #endif
 #endif
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/h/sys.file.h isode-8.0/h/sys.file.h
--- old/isode-8.0/h/sys.file.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0/h/sys.file.h	Thu Sep 16 10:36:05 1993
@@ -31,7 +31,7 @@
 #include <sys/ioctl.h>
 #endif
 
-#ifdef  BSD42
+#if defined(BSD42) || defined(__linux__)
 #include <sys/file.h>
 #else    
 #ifdef  SYS5
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/h/usr.dirent.h isode-8.0/h/usr.dirent.h
--- old/isode-8.0/h/usr.dirent.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0/h/usr.dirent.h	Fri Dec  3 13:27:48 1993
@@ -56,8 +56,9 @@
 
 extern char             *getcwd ();
 
-
+#ifndef __linux__
 #define	scandir	_scandir
 #define	alphasort _alphasort
+#endif
 
 extern char *direntversion;
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/imisc/Makefile isode-8.0/imisc/Makefile
--- old/isode-8.0/imisc/Makefile	Tue Jun 16 13:23:44 1992
+++ isode-8.0/imisc/Makefile	Mon Aug 23 13:49:29 1993
@@ -73,6 +73,7 @@
 		-@echo ""
 
 imiscd:		ximiscd$(LPP)
+		:
 
 ximiscd$(LPP):	imiscd.o IMISC-Rops.o ryresponder.o IMISC_tables.o $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ imiscd.o IMISC-Rops.o ryresponder.o \
@@ -107,6 +108,7 @@
 		-@echo ""
 
 imisc:		ximisc$(LPP)
+		:
 
 ximisc$(LPP):	imisc.o IMISC-Iops.o ryinitiator.o IMISC_tables.o $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ imisc.o IMISC-Iops.o ryinitiator.o \
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/jump/Makefile isode-8.0/jump/Makefile
--- old/isode-8.0/jump/Makefile	Thu Jan  1 01:00:00 1970
+++ isode-8.0/jump/Makefile	Fri Aug 27 12:16:36 1993
@@ -0,0 +1,42 @@
+IMAGE=		libisode
+VERSION=	0.1
+ADDRESS=	0x63d00000
+JUMPSIZE=	0x8000
+GOTSIZE=	0x2000
+
+
+all:		image stubs
+
+install:
+		ln -f libdsap.sa ../libdsap.a
+		ln -f libftam.sa ../libftam.a
+		ln -f libisode.sa ../libacsap.a
+		ln -f libisode.sa ../libcompat.a
+		ln -f libisode.sa ../libdirent.a
+		ln -f libisode.sa ../libisode.a
+		ln -f libisode.sa ../libpepsy.a
+		ln -f libisode.sa ../libpepy.a
+		ln -f libisode.sa ../libpsap.a
+		ln -f libisode.sa ../libpsap2.a
+		ln -f libisode.sa ../libronot.a
+		ln -f libisode.sa ../librosap.a
+		ln -f libisode.sa ../librosy.a
+		ln -f libisode.sa ../librtsap.a
+		ln -f libisode.sa ../libssap.a
+		ln -f libisode.sa ../libtsap.a
+
+image:
+		/usr/dll/bin/mkimage -l $(IMAGE) -v $(VERSION) \
+			-a $(ADDRESS) -j $(JUMPSIZE) -g $(GOTSIZE) \
+			-- \
+			libacsap.a libcommon.a libcompat.a libdirent.a \
+			libdsap.a libftam.a libnet.a libpepsy.a libpepy.a \
+			libpsap.a libpsap2.a libronot.a librosap.a librosy.a \
+			librtsap.a libssap.a libtsap.a libx500as.a libisode.a \
+			-lcurses -ltermcap -ldbm -lc -lm `gcc --print` -lc
+
+stubs:
+		/usr/dll/bin/mkstubs -l $(IMAGE) -v $(VERSION) \
+			-a $(ADDRESS) -j $(JUMPSIZE) -g $(GOTSIZE) \
+			-- \
+			libisode libdsap libftam
